"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.reCasedObjectFrom = void 0;
var core_1 = require("../core");
function reCasedObjectFrom(_a) {
    var jsonObj = _a.jsonObj, casingChange = _a.casingChange, firstCharModifier = _a.firstCharModifier;
    var replacementObj = core_1.isArray(jsonObj) ? [] : {};
    if (jsonObj == null)
        return jsonObj;
    if (core_1.isPrimitive(jsonObj))
        return jsonObj;
    for (var key in jsonObj) {
        var properKey = properKeyFrom({ key: key, firstCharModifier: firstCharModifier });
        replacementObj[properKey] = processedObjectFrom({ obj: jsonObj[key], casingChange: casingChange });
    }
    return replacementObj;
}
exports.reCasedObjectFrom = reCasedObjectFrom;
function processedObjectFrom(_a) {
    var obj = _a.obj, casingChange = _a.casingChange;
    return typeof (obj) == "object" ? casingChange(obj) : obj;
}
function properKeyFrom(_a) {
    var key = _a.key, firstCharModifier = _a.firstCharModifier;
    return firstCharModifier(key.charAt(0)) + key.substr(1, key.length - 1);
}
